import express,{Router, Request, Response} from 'express';
import {User} from '../models/User';
import {myDataSource} from '../app-data-source';
import { nanoid } from 'nanoid';
import { PasswordRecovery } from '../models/PasswordRecovery';
import { transporter } from '../helpers';

const router:Router = express.Router();
const dataSource = myDataSource;


/**Make requiest to init recovery process */
router.post ('/', async (req:Request, res:Response):Promise<void |Response>=>{
    const {email} = req.body 
    const user = await dataSource
    .getRepository(User)
    .findOne({
        where:{
            email:email
        }
    })
    if (!user) return res.status(404).send({message:'user not found'})
    const token = nanoid();
    const url = `${process.env.FRONTEND_URL}/reset-password/${token}`;
    try{
        const passwordRecovery =  await new PasswordRecovery()
        passwordRecovery.user= user
        passwordRecovery.token=token
        passwordRecovery.save()
        await transporter.sendMail({
            from:"planner45@yandex.com",
            to: `${email}`,
            subject:"Запрос на восстановление пароля",
            text:`Вы отправили запрос на восстановление пароля, 
            перейдите по ссылке плз:{url}`,
            html:`Вы отправили запрос на восстановление пароля,
             перейдите по ссылке плз: <br><a> href="${url} ">${url}</a>`});
            return res.send({message:'Email succeffuly send'})
    } catch (e){
        console.log(e)
        res.status(502).send({message:'mail got stuck'})
    }
})

/**validate token t*/
router.get("/validate", async(req: Request, res: Response):Promise<Response>=>{
    const token = req.query.token;
    // if (!token)  return res.send({message:'token is not valid'})
    // const passwordRecovery = await dataSource
    // .getRepository(PasswordRecovery)
    // .findOne({
    //     where:{
    //         token: token
    //     }
    // })
    // if (!passwordRecovery)  return res.send({message:'link is not valid'})
    return res.send(token);
})

export default router;